import { OnInit, OnDestroy, AfterViewInit, EventEmitter, ElementRef, NgZone } from '@angular/core';
import { ScrollObservable } from './utils/scroll-observable';
import { WindowRuler } from './utils/viewport-ruler';
import { ElementBoundingPositions } from './utils/models';
import 'rxjs/add/operator/merge';
import 'rxjs/add/operator/debounce';
import 'rxjs/add/operator/mergeMap';
import 'rxjs/add/operator/filter';
import 'rxjs/add/operator/do';
import 'rxjs/add/observable/of';
import { Subject } from 'rxjs/Subject';
export declare class InviewContainerDirective implements OnInit, OnDestroy, AfterViewInit {
    private _element;
    private _scrollObservable;
    private _windowRuler;
    private _zone;
    private _scrollSuscription;
    private _throttleType;
    private _offset;
    private _viewPortOffset;
    private _throttle;
    private _scrollWindow;
    private _data;
    private _bestMatch;
    private _lastScrollY;
    private _scrollDirection;
    trigger: Subject<any>;
    offset: Array<number | string> | number | string;
    viewPortOffset: Array<number> | number | string;
    throttle: number;
    scrollWindow: boolean;
    data: any;
    bestMatch: any;
    inview: EventEmitter<any>;
    private _inviewChildren;
    constructor(_element: ElementRef, _scrollObservable: ScrollObservable, _windowRuler: WindowRuler, _zone: NgZone);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private _checkScrollDirection();
    private _getViewPortRuler();
    ngOnDestroy(): void;
    handleOnScroll(containersBounds: ElementBoundingPositions): void;
}
